
public class Laberinto {

	private static final int ROWS = 10;
	private static final int COLS = 10;
	private static final char PARED = 'P';
	private static final char CAMINO = 'C';
	private static final char VISITED = 'V';
	private static final char QUESO = 'Q';
	private static char[][] lab = 
		{ 
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  QUESO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO },
		  {  CAMINO, CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO , CAMINO, CAMINO, CAMINO }
		};

	public static String findCheese(int row, int col) {
		System.out.println("row: " + row + " col: " + col);
		if (row >= ROWS || col >= COLS || row < 0 || col < 0) {
			// mouse outside labyrinth
			return "";
		}
		else if (lab[row][col] != CAMINO && lab[row][col] != QUESO) {
			return "";
		}
		else if (lab[row][col] == QUESO) {
			return "Q";
		}
		else { // lab[row][col] == CAMINO
			lab[row][col] = VISITED;
			String caminoAlFrente = findCheese(row-1,col);
			if (caminoAlFrente.length() > 0) {
				return "F"+caminoAlFrente;
			}

			String caminoAlLaDerecha = findCheese(row,col+1);
			if (caminoAlLaDerecha.length() > 0) {
				return "D"+caminoAlLaDerecha;
			}

			String caminoAAtras = findCheese(row+1,col);
			if (caminoAAtras.length() > 0) {
				return "A"+caminoAAtras;
			}

			String caminoALaIzquierda = findCheese(row,col-1);
			if (caminoALaIzquierda.length() > 0) {
				return "I"+caminoALaIzquierda;
			}
			return "";
		}
	}
}
